  module IT_convert_su_file
   @@_it_custom_convert_su_file_defaults = []
def self.main
require "tempfile" if Sketchup.version.to_i > 16
model = Sketchup.active_model
model.start_operation("Convert Su file",true,false,false) rescue model.start_operation("Convert Su file", true) rescue model.start_operation("Convert Su file")
bcolor = model.rendering_options["BackgroundColor"]

drawhorizon=model.rendering_options["DrawHorizon"]
drawground=model.rendering_options["DrawGround"]
drawunderground=model.rendering_options["DrawUnderground"]
rendermode=model.rendering_options["RenderMode"]

Sketchup.set_status_text "Program is running..."

msg = "Convert ALL Files: Choose TYPE..."


  prompts = [] ; defaults = [] ;  values = []
            
            #[0]
            prompts << "Version"
            values  << '5|6|7|8|13|15|17|18|19|20|21'
            defaults << '8'
            #[1]
            prompts << "Include All Subfolders"
            values  << 'Yes|No'
            defaults << 'No'            
            #[2]
            prompts << "Delete old files"
            values  << 'Yes|No'
            defaults << 'No'
            
 
            
        if @@_it_custom_convert_su_file_defaults != []
        defaults = @@_it_custom_convert_su_file_defaults
        end
            
     results = UI.inputbox( prompts, defaults, values, "New name") 
         
            return nil if not results
        @@_it_custom_convert_su_file_defaults = results


    file=UI.openpanel(msg,"","")
    if not file
      puts "CANCELED."
      Sketchup.send_action("selectSelectionTool:")
      return nil
    end
    model.rendering_options["BackgroundColor"] = [50,50,50]
    model.rendering_options["DrawHorizon"]=false
    model.rendering_options["DrawGround"]=false
    model.rendering_options["DrawUnderground"]=false
    model.rendering_options["RenderMode"]=1
  path = __FILE__
  @@plugindir = File.join(File.dirname(path), 'ithil_convertsufile')
  @@suversion = results[0].to_i
  @@_all_exists = 1
  include_all_subfolders = (if results[1]=='Yes' then true else false end)
  delit_old = (if results[2]=='Yes' then true else false end)
    
 
      file=file.tr("\\","/")
      @@folder=folder=File.dirname(file)
      type=File.extname(file).downcase
      list=[]
      

     if include_all_subfolders
       librbfiles = File.join( folder, "**", "*.skp")
     else
      librbfiles = File.join( folder, "*.skp")
     end
      
 list =  Dir.glob(librbfiles)
 
 if list.size > 20 && include_all_subfolders
 result = UI.messagebox("#{list.size} files in subfolders will be converted.\nClick 'Yes' to confirm", MB_YESNOCANCEL)
    if result != IDYES
      return
    end
 end

    
     list.each{|e| 
     t = "#{File.basename(e, '.skp')} v#{@@suversion}.skp"
     folder=File.dirname(e)
     f1 = File.join(folder,t)
     @@target_file = f1
    @@status_text =  "#{@@_all_exists} - (#{list.size}) #{t}"
     Sketchup.status_text = @@status_text
     convert_and_open(e,f1) 
     }
     
     f_last = "#{File.basename(list[-1], '.skp')} v#{@@suversion}.skp"
     f_last_long = File.join(folder,f_last)


     timer1 = UI.start_timer(2 , true) {
     if @@_all_exists > list.size
         UI.stop_timer(timer1)
     
         if delit_old
         sleep(1)
         list.reverse.each{|e|File.delete(e) }
         end
         
         model.rendering_options["BackgroundColor"] = bcolor
         model.rendering_options["DrawHorizon"]=drawhorizon
         model.rendering_options["DrawGround"]=drawground
         model.rendering_options["DrawUnderground"]=drawunderground
         model.rendering_options["RenderMode"]=rendermode
         if Sketchup.version.to_i < 17
         File.delete(File.join( @@folder, "temp.vbs"))
         end
         UI.openURL(folder)
         Sketchup.set_status_text "Done!"
         model.commit_operation
    end
  }  
end

  def self.convert_and_open(source, target)
    Sketchup.status_text = @@status_text

    # Since the hack for running the system command without a flashing window
    # makes the call asynchronous, we need to wait to open the converted model
    # until its file exists. To check for file creation, we must first make sure
    # there is no existing file by the same name already.
    File.delete(target) if File.exist?(target)

    system_call(%("#{@@plugindir}/bin/ConvertVersion" "#{source}" "#{target}" #{@@suversion}))
    # on_exist(target, false) { Sketchup.open_file(target) }

    nil
  end
   
  def self.system_call(cmd)
  Sketchup.status_text = @@status_text
    # HACK: Run the command through a VBS script to avoid flashing command line
    # window.
    if Sketchup.version.to_i > 16
    file = Tempfile.new(["cmd", ".vbs"])
    else
    temp_file_name = File.join( @@folder, "temp.vbs")
    file = File.new(temp_file_name, "w")  #rescue (UI.start_timer(1, false) {file = File.new(temp_file_name, "w")})

    end

    file.write("Set WshShell = CreateObject(\"WScript.Shell\")\n")
    file.write("WshShell.Run \"#{cmd.gsub('"', '""')}\", 0\n")
    file.close
    UI.openURL("file://#{file.path}")

begin
    sleep 0.25
end until File.exist?(@@target_file)
        @@_all_exists +=1
    nil
  end
    
 end # module IT_convert_su_file  
    
if( $submenu )
	organizer = $submenu 
    
	if !file_loaded?(__FILE__) then
		organizer.add_item("Convert file") { IT_convert_su_file.main }

	end
else
	if !file_loaded?(__FILE__) then

		$ithil_menu = UI.menu("Plugins").add_submenu("Ithil Tools")
	end
	if !file_loaded?(__FILE__) then
    
  
		$ithil_menu.add_item("Convert file") { IT_convert_su_file.main }
	end
end

file_loaded('ithil_menu_loader')
file_loaded(__FILE__)